
function [pn, rho_eff]=QT(m,mu_j,N,R,c_serv)




N1=N+1; % Nr of customers+1 to account for 0 customers







sizeR=[m m];



RR=zeros(m,m,m);

for y=1:m
         RR(:,:,y)=circshift(R,[y-1 y-1]);
end



for i=1:m
mu_j(i)=mu_j(i)';
end
mu_r=zeros(m,1,m);
for y=1:m
         mu_r(:,:,y)=circshift(mu_j,y-1);
end



mu=zeros(m,m,m);
for y=1:m
    for i =1:m
        mu(i,i,y)=mu_r(i,:,y);
    end
end



for i=1:m
    c(i)=c_serv(i);
end

c=c';


c_2=zeros(N1,m,m);
c_s=zeros(m,1,m);

for y=1:m
         c_s(:,:,y)=circshift(c,y-1);
end


for y=1:m
    for i=1:m
        c_2(:,i,y)=c_s(i,:,y);
    end
end

c=c_2;



%Traffic equations

rho=zeros(m,m,m);


for y=1:m
    rho(:,:,y)=mu(:,:,y)*RR(:,:,y);
end

for y=1:m
    rho(:,:,y)=rho(:,:,y)';
end



for y=1:m
for i=1:m
    rho(i,:,y)=rho(i,:,y)/mu_r(i,1,y);
end
end

for y=1:m
[V(:,:,y),D(:,:,y)]=eig(rho(:,:,y));

rho_eig(:,:,y)=abs(V(:,1,y));
end


% Make one value 1

for y=1:m
[max_value(:,:,y), index(:,:,y)] = max(rho_eig(:,:,y));
end

rho_1=zeros(length(rho_eig),1,m);

corr=zeros(m,1);

for y=1:m
    corr(y)=1/rho_eig(index(:,:,y),y);
end

for y=1:m
    for i=1:length(rho_eig)
        rho_1(i,y)=rho_eig(i,y)*corr(y);
    end
end

 
rho_i=rho_1;



for y=1:m
n(:,:,y)=[0:N];
end
a_i=zeros(N1,m,m);

for y=1:m
    for i=1:N1
        for j=1:m
        if n(1,i,y)<c(i,j,y)
            a_i(i,j,y)=factorial(n(1,i,y));

        elseif n(1,i,y)>=c(i,j,y)
            a_i(i,j,y)=c(i,j,y)^(n(:,i,y)-c(i,j,y))*factorial(c(i,j,y));
        end
        end
    end
end


    
%%%%%%%%%%%%%%%%%%
%%% Buzen's algorithm


F=zeros(N1,m,m);
for y=1:m
    for i=1:N1
        
        F(i,:,y)=rho_i(:,:,y);
    end
end

for y=1:m
    for i=1:N1
        for j=1:m
            F(i,j,y)=F(i,j,y)^(i-1);
        end
    end
end


F=F./a_i;

F=permute(F,[2 1 3]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
g=zeros(m,N1,m);
pn_temp=zeros(N1,m,m);
pn=zeros(N1,m);



for y=1:m

    
    
for i=1:N1
        for j=1:m
            if i==1 || j==1
                g(j,i,y)=1;
            else
                g(j,i,y)=0;
            end
        end
end
    
          
      for j=1:m
         for k=2:N1
            for l=1:m
                if l==1
                    g(l,k,y)=F(l,k,y);
                else
                    g(l,k,y)=0;
                    for k1=1:k
                       g(l,k,y)=g(l,k,y)+F(l,k1,y)*g(l-1,k-(k1-1),y);
                    end
                end
            end
         end
         
         GN = g(m,N1,y);
        G1 = g(m,N,y);
        
         for i=1:N1

             pn_temp(i,j,y) = F(end,i,y)*g(m-1,N1+1-i,y)/GN;
     
         end
      end
   
end



for i=1:m
    pn(:,i,N)=pn_temp(:,end,i);
end

pn=pn(:,:,end);
        csum=sum(pn);
pn=fliplr(pn);      
 
L=zeros(1,m);
    for i=1:m
        for j=2:N1
            L_temp(j,i)=(j-1)*pn(j,i);
            L(i)=L(i)+L_temp(j,i);
        end
    end
 L=fliplr(L);
    
 rho_eff=zeros(1,m);
 for i=1:m
     rho_eff(i)=1-pn(1,i);
     
    
 end
 

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
