
clear all
clc

tic


nvars = 3;

ObjectiveFunction = @objfun;
 
IntCon=[1,3];


LB = [1 0.001 1];   % Lower bound
UB = [10 1 100];  % Upper bound




ConstraintFunction = @constraintfun;


options = gaoptimset('PlotFcns', {@gaplotbestf,@gaplotmaxconstr,@gaplotrange},'FitnessScalingFcn',{
@fitscalingrank },'TolCon', 1e-20, ...
'PopInitRange',[LB ; UB],...% Decides the rangeof variables for the initial population
'StallGenL',100,...
'Generations',100, ... %Sets the number of generations
'PopulationSize',25,...% Sets the populationsize
'EliteCount',2, ... %Size of elite population
'CrossoverFraction',0.4,... % Percentage of the population made of crossover children
'UseParallel','always',... %Enables parallel computing
'MigrationInterval',10,...
'MigrationFraction',0.1,...
'MigrationDirection','both', ...
'PopulationType','doubleVector');

    
[x, fval, exitflag, output, population, scores]...
    = ga(ObjectiveFunction,nvars,[],[],[],[],LB,UB, ...
    ConstraintFunction,IntCon,options)
toc

